#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define SERV_PORT  5134

#define MAXNAME    1024

main()
{
   int dg_fd;                 /* file descriptor into UDP */
   struct sockaddr_in myaddr; /* the addr of this service */
   int len;                   /* length of address        */
   char buff[MAXNAME];        /* buffer to hold datagram  */
   char reply;                /* response to the client   */
   struct sockaddr_in client_addr; /* the addr of client  */

   char cmd[BUFSIZ];          /* used to figure out if    */
   char junkbuf[BUFSIZ];      /* the user is logged onto  */
   FILE *fp;                  /* the system               */
   /*
    *  Open a socket into UDP/IP.
    */

   if ((dg_fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
      perror("socket failed");
      exit(1);
   }

   /*
    *  Set up our address.
    */

   bzero((char *)&myaddr, sizeof(myaddr));
   myaddr.sin_family = AF_INET;
   myaddr.sin_addr.s_addr = htonl(INADDR_ANY);
   myaddr.sin_port = htons(SERV_PORT);

   /*
    *  Bind to the address of this service.
    */

   if (bind(dg_fd, (struct sockaddr *)&myaddr,
                 sizeof(myaddr)) < 0) {
      perror("bind failed");
      exit(1);
   }
   /*
    *  Loop continuously, processing datagrams.
    */

   len = sizeof(struct sockaddr);
   while (1) {
      if (recvfrom(dg_fd, buff, MAXNAME, 0,
               &client_addr, &len) < 0) {
         perror("could not read datagram!");
         continue;
      }

      sprintf(cmd, "who | grep '^%s '", buff);
      if ((fp = popen(cmd, "r")) == NULL
       || fgets(junkbuf, BUFSIZ, fp) == NULL) {
         reply = 'n';
      } else {
         reply = 'y';
      }
      if (sendto(dg_fd, &reply, 1, 0, &client_addr, len) < 0) {
         perror("could not send datagram!");
         continue;
      }
   }
}
